<?php

session_start();

define('ACTION_READ', 'read');
define('ACTION_WRITE', 'write');
define('ACTION_END_SESSION', 'end');
define('WRITE_KEY', 'key');
define('WRITE_VALUE', 'value');


/**
 * Checks if the given parameters are set. If one of the specified parameters is not set,
 * die() is called.
 *
 * @param $parameters The parameters to check.
 */
function checkGETParametersOrDie($parameters) {
    foreach ($parameters as $parameter) {
        isset($_GET[$parameter]) || die("Please, provide '$parameter' parameter.");
    }
}

/**
 * Destroys the session completely, including the cookie where the session id is stored.
 *
 * @return Value returned by session_destroy().
 */
function destroySession() {
    $_SESSION = [];
    $cookieParameters = session_get_cookie_params();

    setcookie(session_name(), '', time(), $cookieParameters['path'], $cookieParameters['domain'],
        $cookieParameters['secure'], $cookieParameters['httponly']);

    $destroyed = session_destroy();

    return $destroyed;
}

// Flow starts here.
echo "Your session ID is '" . session_id() . "'.<br><br>";

checkGETParametersOrDie(['action']);

$action = $_GET['action'];

switch($action) {
    case ACTION_READ:
        $response = 'Session data:<br>';

        foreach ($_SESSION as $key => $value) {
            $response .= "'$key' => '$value'<br>";
        }

        break;

    case ACTION_WRITE:
        checkGETParametersOrDie([WRITE_KEY, WRITE_VALUE]);
        $key = $_GET[WRITE_KEY];
        $value = $_GET[WRITE_VALUE];

        $response = "Saving '$value' with '$key' key into session data.";
        $_SESSION[$key] = $value;

        break;

    case ACTION_END_SESSION:
	    $destroyed = destroySession();

        if ($destroyed) {
            $response = 'Session has ended successfully.';
        } else {
            $response = 'Some problem occured when trying to end the session.';
        }

        break;

    default:
        $response = "Please, provide a valid 'action' parameter.";
        break;
}

echo $response;

        
